#!/usr/bin/python -u
# coding: utf-8

#--------------------------------------------------------------------
# Fichero:  3-inserta-nuc.py
# Objetivo: Insertar en la base de datos nombre, usuario y contraseña
# Fecha:    D.10.11.2019
# Autor:    Pedro Reina
# Licencia: Dominio público
#           https://creativecommons.org/publicdomain/zero/1.0/deed.es
#--------------------------------------------------------------------

#------------------------------------------------
# Variables del programa
#------------------------------------------------

# Archivo con nombre, usuario y contraseña. Codificación UTF-8
Origen = 'maxifeli-nuc.csv'

# El archivo con la base de datos
BaseDato = 'maxifeli.db'

#------------------------------------------------
# Módulos necesarios
#------------------------------------------------

# Another Python SQLite Wrapper
import apsw

# Leer archivos en UTF-8
import codecs

# Llamadas al sistema
import os

#------------------------------------------------
# Variables globales
#------------------------------------------------

# La lista con los Nuc
ListaNuc = []

#------------------------------------------------
# Funciones
#------------------------------------------------

#------------------------------------------------
# Lee un archivo UTF-8 y devuelve una lista con las líneas no vacías
def LeeDatos(Origen):
    ListaDatos = []

    Entrada = codecs.open(Origen, encoding='utf-8', mode='r')
    for Linea in Entrada:
        if len(Linea):
            ListaDatos.append (Linea)

    return ListaDatos

#------------------------------------------------
# Devuelve un hash criptográficamente fuerte de una cadena
def CadenaHash(Cadena):
    # Obtenemos el hash de la cadena con una llamada a PHP
    Cadena = os.popen('./passhash.php ' + Cadena).read()

    # La devolvemos
    return Cadena

#------------------------------------------------
def InsertaNuc(Conexion):
    Consulta = ('INSERT INTO acceso VALUES (:Usuario, :Nombre, :Codigo)')
    Cursor = Conexion.cursor()

    # Para cada nuc
    for Nuc in ListaNuc:
        # Preparamos todos sus datos
        DatoNuc = Nuc.split(',')
        Nombre = DatoNuc[0]
        Usuario = DatoNuc[1]
        Codigo = CadenaHash(DatoNuc[2])

        # Los almacenamos en la base de datos
        Cursor.execute(Consulta, locals())

#------------------------------------------------
# El programa
#------------------------------------------------

# Informamos al usuario
print '3-inserta-nuc'
print '============='
print

# Leemos los datos
print 'Archivo origen:', Origen
print 'Leyendo origen...',
ListaNuc = LeeDatos(Origen)
# La primera línea es una cabecera, la quitamos
ListaNuc.pop(0)
print 'hecho.'

# Almacenamos los datos
print 'Base de datos:', BaseDato
print 'Insertando datos...',
# Abrimos conexión a la base de datos
Conexion = apsw.Connection(BaseDato)
InsertaNuc(Conexion)
print 'hecho.'

# Cerramos la conexión
Conexion.close(True)

# Hemos acabado; informamos al usuario
print 'Terminado.'
