/* ------------------------------------------------------------------
 * Fichero:  maxifeli.sql
 * Objetivo: Crear la base de datos maxifeli.db
 * Fecha:    L.4.11.2019
 * Autor:    Pedro Reina
 * Licencia: Dominio público
 * Orden:    sqlite3 maxifeli.db ".maxifeli evin.sql"
-------------------------------------------------------------------*/

/* Los datos para acceder al sistema via web */

CREATE TABLE acceso (
  usuario TEXT PRIMARY KEY,   -- El nombre de usuario (ASCII)
  nombre TEXT,                -- El nombre completo (UTF-8)
  codigo TEXT                 -- El hash de la contraseña (ASCII)
  );


/* Las preferencias */

CREATE TABLE preferencia (
  activo TEXT, -- El usuario que expresa una preferencia
  pasivo TEXT, -- Sobre quién la expresa
  cantidad INTEGER (1),  -- La cantidad de la preferencia (1..5)
  FOREIGN KEY(activo) REFERENCES acceso(usuario),
  FOREIGN KEY(pasivo) REFERENCES acceso(usuario),
  UNIQUE (activo, pasivo) -- Solo se puede expresar una cantidad en cada pareja
  );
